%define name   geas
%define ver    0.0.6 
%define prefix     /usr
%define sysconfdir /etc

%define  RELEASE 1
%define  rel     %{?CUSTOM_RELEASE} %{!?CUSTOM_RELEASE:%RELEASE}

Summary: GNU Enterprise CORBA Object Server.
Name: 		%name 
Version: 	%ver
Release: 	%rel
Source: 	http://www.gnue.org/downloads/geas-%{PACKAGE_VERSION}.tar.gz
Group: 	 	Applications/Databases
Copyright: 	LGPL/GPL
BuildRoot: 	/var/tmp/geas-%{PACKAGE_VERSION}-root
Prefix: 	%{prefix}
Docdir: 	%{prefix}/doc
Prereq: 	/sbin/install-info
URL: 		http://www.gnue.org/geas/

%description
GEAS is the GNU Enterprise Application/Object Server

%package devel
Summary: GNU Enterprise CORBA Object Server Development
Group:		Applications/Databases
#Requires:	%name = %{PACKAGE_VERSION}

%description devel
GEAS Development Files

%package python
Summary: GNU Enterprise GEAS Python object bindings
Group:		Applications/Databases

%description python
GEAS Python bindings

%prep
%setup

%build
# Needed for snapshot releases.
#MYCFLAGS="-DG_DISABLE_ASSERT -DG_DISABLE_CHECKS $RPM_OPT_FLAGS"
MYCFLAGS="$RPM_OPT_FLAGS"
CONF_VARS="--prefix=/usr --sysconfdir=/etc --localstatedir=/var --with-mysql --with-dmalloc=no"
if [ ! -f configure ]; then
	CFLAGS="$MYCFLAGS" ./autogen.sh --prefix=%prefix $CONF_VARS
else
	CFLAGS="$MYCFLAGS" ./configure --prefix=%prefix $CONF_VARS
fi
make

%install
rm -rf $RPM_BUILD_ROOT

make prefix=$RPM_BUILD_ROOT%{prefix} \
sysconfdir=$RPM_BUILD_ROOT%{sysconfdir} \
idldir=$RPM_BUILD_ROOT%{prefix}/share/idl \
geasclassdatadir=$RPM_BUILD_ROOT/var/lib/geas/classdir \
geasmethoddatadir=$RPM_BUILD_ROOT/var/lib/geas/methods \
install

/sbin/ldconfig -n $RPM_BUILD_ROOT%{prefix}/lib

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)

%doc AUTHORS COPYING ChangeLog NEWS README TODO FAQ

%{prefix}/bin/geas-server
%{prefix}/bin/kill-geas-server

%files devel
%defattr(-, root, root)

%{prefix}/share/idl/*

%files python
%defattr(-, root, root)
%{prefix}/lib/python1.5/site-packages/gnue/geas/*

%config
%{sysconfdir}/geas.conf

%changelog
