#include "geas.h"

/*** App-specific servant structures ***/

typedef struct
{
   POA_GEAS_Query_Constraint servant;
   PortableServer_POA poa;
   GEAS_Query_logictype attr_logic;

}
impl_POA_GEAS_Query_Constraint;

typedef struct
{
   POA_GEAS_Query_Query servant;
   PortableServer_POA poa;
   GEAS_ObjectReference attr_id;

   CORBA_char *attr_classname;

   CORBA_char *attr_orderby;

   CORBA_boolean attr_reverse;

   GEAS_Query_logictype attr_logic;
}
impl_POA_GEAS_Query_Query;

typedef struct
{
   POA_GEAS_Admin servant;
   PortableServer_POA poa;
   CORBA_long attr_debuglevel;

   CORBA_boolean attr_verbose;

}
impl_POA_GEAS_Admin;

typedef struct
{
   POA_GEAS_Transaction servant;
   PortableServer_POA poa;

}
impl_POA_GEAS_Transaction;

typedef struct
{
   POA_GEAS_TransactionFactory servant;
   PortableServer_POA poa;

}
impl_POA_GEAS_TransactionFactory;

typedef struct
{
   POA_GEAS_Connection servant;
   PortableServer_POA poa;
   CORBA_char *attr_currentUserID;

   GEAS_classnames attr_classes;

   GEAS_classlist attr_schema;

   GEAS_Changes attr_latestChanges;

}
impl_POA_GEAS_Connection;

typedef struct
{
   POA_GEAS_DataObject servant;
   PortableServer_POA poa;
   GEAS_ObjectReference attr_objectID;

   CORBA_char *attr_classname;

   GEAS_classnames attr_classes;

   GEAS_fieldlist attr_allfields;

   CORBA_boolean attr_inDatabase;

}
impl_POA_GEAS_DataObject;

typedef struct
{
   POA_GEAS_ObjectList servant;
   PortableServer_POA poa;
   CORBA_unsigned_long attr_length;

   GEAS_objectslist attr_objects;

   CORBA_char *attr_classname;

   CORBA_boolean attr_delayFilter;

}
impl_POA_GEAS_ObjectList;

typedef struct
{
   POA_GEAS_ConnectionFactory servant;
   PortableServer_POA poa;

}
impl_POA_GEAS_ConnectionFactory;

typedef struct
{
   POA_GEAS_MethodProvider servant;
   PortableServer_POA poa;

}
impl_POA_GEAS_MethodProvider;

/*** Implementation stub prototypes ***/

static void impl_GEAS_Query_Constraint__destroy(impl_POA_GEAS_Query_Constraint
						* servant,

						CORBA_Environment * ev);
static GEAS_Query_logictype
impl_GEAS_Query_Constraint__get_logic(impl_POA_GEAS_Query_Constraint *
				      servant, CORBA_Environment * ev);
static void
impl_GEAS_Query_Constraint__set_logic(impl_POA_GEAS_Query_Constraint *
				      servant, GEAS_Query_logictype value,
				      CORBA_Environment * ev);

static void
impl_GEAS_Query_Constraint_addField(impl_POA_GEAS_Query_Constraint * servant,
				    GEAS_Query_Field * field,
				    CORBA_Environment * ev);

static GEAS_Query_Constraint
impl_GEAS_Query_Constraint_newConstraint(impl_POA_GEAS_Query_Constraint *
					 servant, CORBA_Environment * ev);

static void impl_GEAS_Query_Query__destroy(impl_POA_GEAS_Query_Query *
					   servant, CORBA_Environment * ev);
static GEAS_ObjectReference
impl_GEAS_Query_Query__get_id(impl_POA_GEAS_Query_Query * servant,
			      CORBA_Environment * ev);

static void
impl_GEAS_Query_Query_release(impl_POA_GEAS_Query_Query * servant,
			      CORBA_Environment * ev);

static void
impl_GEAS_Query_Query_clear(impl_POA_GEAS_Query_Query * servant,
			    CORBA_Environment * ev);

static CORBA_char
   *impl_GEAS_Query_Query__get_classname(impl_POA_GEAS_Query_Query * servant,
					 CORBA_Environment * ev);
static void impl_GEAS_Query_Query__set_classname(impl_POA_GEAS_Query_Query *
						 servant, CORBA_char * value,
						 CORBA_Environment * ev);

static CORBA_char
   *impl_GEAS_Query_Query__get_orderby(impl_POA_GEAS_Query_Query * servant,
				       CORBA_Environment * ev);
static void impl_GEAS_Query_Query__set_orderby(impl_POA_GEAS_Query_Query *
					       servant, CORBA_char * value,
					       CORBA_Environment * ev);

static CORBA_boolean
impl_GEAS_Query_Query__get_reverse(impl_POA_GEAS_Query_Query * servant,
				   CORBA_Environment * ev);
static void
impl_GEAS_Query_Query__set_reverse(impl_POA_GEAS_Query_Query * servant,
				   CORBA_boolean value,

				   CORBA_Environment * ev);

static GEAS_Query_logictype
impl_GEAS_Query_Query__get_logic(impl_POA_GEAS_Query_Query * servant,
				 CORBA_Environment * ev);
static void
impl_GEAS_Query_Query__set_logic(impl_POA_GEAS_Query_Query * servant,
				 GEAS_Query_logictype value,
				 CORBA_Environment * ev);
static void
impl_GEAS_Query_Query_addField(impl_POA_GEAS_Query_Query * servant,
			       GEAS_Query_Field * field,

			       CORBA_Environment * ev);
static GEAS_Query_Constraint
impl_GEAS_Query_Query_newConstraint(impl_POA_GEAS_Query_Query * servant,
				    CORBA_Environment * ev);

static void impl_GEAS_Admin__destroy(impl_POA_GEAS_Admin * servant,
				     CORBA_Environment * ev);
static CORBA_long
impl_GEAS_Admin__get_debuglevel(impl_POA_GEAS_Admin * servant,
				CORBA_Environment * ev);
static void
impl_GEAS_Admin__set_debuglevel(impl_POA_GEAS_Admin * servant,
				CORBA_long value, CORBA_Environment * ev);

static CORBA_boolean
impl_GEAS_Admin__get_verbose(impl_POA_GEAS_Admin * servant,
			     CORBA_Environment * ev);
static void
impl_GEAS_Admin__set_verbose(impl_POA_GEAS_Admin * servant,
			     CORBA_boolean value, CORBA_Environment * ev);

static void
impl_GEAS_Admin_restart(impl_POA_GEAS_Admin * servant,

			CORBA_Environment * ev);

static void
impl_GEAS_Admin_shutdown(impl_POA_GEAS_Admin * servant,

			 CORBA_Environment * ev);

static void impl_GEAS_Transaction__destroy(impl_POA_GEAS_Transaction *
					   servant, CORBA_Environment * ev);
static void impl_GEAS_Transaction_begin(impl_POA_GEAS_Transaction * servant,
					CORBA_Environment * ev);

static void
impl_GEAS_Transaction_commit(impl_POA_GEAS_Transaction * servant,
			     CORBA_Environment * ev);

static void
impl_GEAS_Transaction_abort(impl_POA_GEAS_Transaction * servant,
			    CORBA_Environment * ev);

static void
impl_GEAS_Transaction_checkpoint(impl_POA_GEAS_Transaction * servant,
				 CORBA_Environment * ev);

static void
impl_GEAS_Transaction_join(impl_POA_GEAS_Transaction * servant,
			   CORBA_Environment * ev);

static void
impl_GEAS_Transaction_leave(impl_POA_GEAS_Transaction * servant,
			    CORBA_Environment * ev);

static CORBA_boolean
impl_GEAS_Transaction_isOpen(impl_POA_GEAS_Transaction * servant,
			     CORBA_Environment * ev);

static void
impl_GEAS_TransactionFactory__destroy(impl_POA_GEAS_TransactionFactory *
				      servant, CORBA_Environment * ev);
static GEAS_Transaction
impl_GEAS_TransactionFactory_new(impl_POA_GEAS_TransactionFactory * servant,
				 CORBA_Environment * ev);

static GEAS_Transaction
impl_GEAS_TransactionFactory_current(impl_POA_GEAS_TransactionFactory *
				     servant, CORBA_Environment * ev);

static void impl_GEAS_Connection__destroy(impl_POA_GEAS_Connection * servant,
					  CORBA_Environment * ev);
static CORBA_char
   *impl_GEAS_Connection__get_currentUserID(impl_POA_GEAS_Connection *
					    servant, CORBA_Environment * ev);

static GEAS_classnames
   *impl_GEAS_Connection__get_classes(impl_POA_GEAS_Connection * servant,
				      CORBA_Environment * ev);

static GEAS_classlist
   *impl_GEAS_Connection__get_schema(impl_POA_GEAS_Connection * servant,
				     CORBA_Environment * ev);

static GEAS_Query_Query
impl_GEAS_Connection_newQuery(impl_POA_GEAS_Connection * servant,
			      CORBA_Environment * ev);

static GEAS_ObjectList
impl_GEAS_Connection_executeQuery(impl_POA_GEAS_Connection * servant,
				  GEAS_Query_Query querytoperform,
				  CORBA_Environment * ev);

static GEAS_ClassDefinition
   *impl_GEAS_Connection_getClassDefinition(impl_POA_GEAS_Connection *
					    servant, CORBA_char * name,
					    CORBA_Environment * ev);

static GEAS_ClassDefinition
   *impl_GEAS_Connection_getFullClassDefinition(impl_POA_GEAS_Connection *
						servant, CORBA_char * name,
						CORBA_Environment * ev);

static GEAS_LookupOptions
   *impl_GEAS_Connection_getLookupFieldOptions(impl_POA_GEAS_Connection *
					       servant,
					       CORBA_char * classname,
					       CORBA_char * fieldname,
					       CORBA_Environment * ev);

static CORBA_boolean
impl_GEAS_Connection_supportsFeature(impl_POA_GEAS_Connection * servant,
				     GEAS_Feature featureID,
				     CORBA_Environment * ev);

static GEAS_DataObject
impl_GEAS_Connection_newObject(impl_POA_GEAS_Connection * servant,
			       CORBA_char * classname,

			       CORBA_Environment * ev);

static GEAS_ObjectList
impl_GEAS_Connection_newEmptyList(impl_POA_GEAS_Connection * servant,
				  CORBA_char * classname,

				  CORBA_Environment * ev);

static GEAS_ObjectList
impl_GEAS_Connection_loadObjects(impl_POA_GEAS_Connection * servant,
				 CORBA_char * classname,
				 CORBA_char * fieldname,
				 CORBA_char * searchvalue,

				 CORBA_Environment * ev);

static GEAS_ObjectList
impl_GEAS_Connection_loadAll(impl_POA_GEAS_Connection * servant,
			     CORBA_char * classname, CORBA_Environment * ev);

static GEAS_DataObject
impl_GEAS_Connection_loadSingleObject(impl_POA_GEAS_Connection * servant,
				      CORBA_char * classname,
				      CORBA_char * fieldname,
				      CORBA_char * searchvalue,
				      CORBA_Environment * ev);

static void
impl_GEAS_Connection_flush(impl_POA_GEAS_Connection * servant,
			   CORBA_Environment * ev);

static void
impl_GEAS_Connection_logout(impl_POA_GEAS_Connection * servant,
			    CORBA_Environment * ev);

static GEAS_LoadDefinition
   *impl_GEAS_Connection_getReferenceDefinition(impl_POA_GEAS_Connection *
						servant,
						CORBA_char * classname,
						CORBA_char * fieldname,
						CORBA_Environment * ev);

static void
impl_GEAS_Connection_clearCache(impl_POA_GEAS_Connection * servant,
				CORBA_Environment * ev);

static void
impl_GEAS_Connection_activateEventLog(impl_POA_GEAS_Connection * servant,
				      CORBA_Environment * ev);

static GEAS_Changes
   *impl_GEAS_Connection__get_latestChanges(impl_POA_GEAS_Connection *
					    servant, CORBA_Environment * ev);

static CORBA_unsigned_long
impl_GEAS_Connection_countAllInstances(impl_POA_GEAS_Connection * servant,
				       CORBA_char * classname,
				       CORBA_Environment * ev);

static GEAS_Transaction
impl_GEAS_Connection_new(impl_POA_GEAS_Connection * servant,
			 CORBA_Environment * ev);
static GEAS_Transaction
impl_GEAS_Connection_current(impl_POA_GEAS_Connection * servant,
			     CORBA_Environment * ev);

static void impl_GEAS_DataObject__destroy(impl_POA_GEAS_DataObject * servant,
					  CORBA_Environment * ev);
static GEAS_ObjectReference
impl_GEAS_DataObject__get_objectID(impl_POA_GEAS_DataObject * servant,
				   CORBA_Environment * ev);

static CORBA_boolean
impl_GEAS_DataObject_identity(impl_POA_GEAS_DataObject * servant,
			      CORBA_char * classname,
			      CORBA_char * oid, CORBA_Environment * ev);

static CORBA_boolean
impl_GEAS_DataObject_ofclass(impl_POA_GEAS_DataObject * servant,
			     CORBA_char * classname, CORBA_Environment * ev);

static CORBA_char
   *impl_GEAS_DataObject__get_classname(impl_POA_GEAS_DataObject * servant,
					CORBA_Environment * ev);

static GEAS_classnames
   *impl_GEAS_DataObject__get_classes(impl_POA_GEAS_DataObject * servant,
				      CORBA_Environment * ev);

static GEAS_fieldlist
   *impl_GEAS_DataObject__get_allfields(impl_POA_GEAS_DataObject * servant,
					CORBA_Environment * ev);

static GEAS_LookupOptions
   *impl_GEAS_DataObject_getLookupFieldOptions(impl_POA_GEAS_DataObject *
					       servant,
					       CORBA_char * fieldname,
					       CORBA_Environment * ev);

static void
impl_GEAS_DataObject_setLookupField(impl_POA_GEAS_DataObject * servant,
				    GEAS_LookupOption * setting,
				    CORBA_Environment * ev);

static CORBA_char *impl_GEAS_DataObject_getField(impl_POA_GEAS_DataObject *
						 servant,
						 CORBA_char * fieldname,
						 CORBA_Environment * ev);

static void
impl_GEAS_DataObject_setField(impl_POA_GEAS_DataObject * servant,
			      CORBA_char * fieldname,
			      CORBA_char * value, CORBA_Environment * ev);

static GEAS_DataObject
impl_GEAS_DataObject_getReference(impl_POA_GEAS_DataObject * servant,
				  CORBA_char * fieldname,

				  CORBA_Environment * ev);

static GEAS_ObjectList
impl_GEAS_DataObject_getList(impl_POA_GEAS_DataObject * servant,
			     CORBA_char * fieldname, CORBA_Environment * ev);

static void
impl_GEAS_DataObject_insert(impl_POA_GEAS_DataObject * servant,
			    CORBA_char * fieldname,
			    GEAS_DataObject obj, CORBA_Environment * ev);

static void
impl_GEAS_DataObject_setReference(impl_POA_GEAS_DataObject * servant,
				  CORBA_char * fieldname,
				  GEAS_DataObject obj,

				  CORBA_Environment * ev);

static void
impl_GEAS_DataObject_flush(impl_POA_GEAS_DataObject * servant,
			   CORBA_Environment * ev);

static void
impl_GEAS_DataObject_delete(impl_POA_GEAS_DataObject * servant,
			    CORBA_Environment * ev);

static CORBA_char *impl_GEAS_DataObject_callMethod(impl_POA_GEAS_DataObject *
						   servant,
						   CORBA_char * methodname,
						   GEAS_Arguments * args,
						   CORBA_Environment * ev);

static CORBA_boolean
impl_GEAS_DataObject__get_inDatabase(impl_POA_GEAS_DataObject * servant,
				     CORBA_Environment * ev);

static void impl_GEAS_ObjectList__destroy(impl_POA_GEAS_ObjectList * servant,
					  CORBA_Environment * ev);
static CORBA_unsigned_long
impl_GEAS_ObjectList__get_length(impl_POA_GEAS_ObjectList * servant,
				 CORBA_Environment * ev);

static GEAS_objectslist
   *impl_GEAS_ObjectList__get_objects(impl_POA_GEAS_ObjectList * servant,
				      CORBA_Environment * ev);

static CORBA_char
   *impl_GEAS_ObjectList__get_classname(impl_POA_GEAS_ObjectList * servant,
					CORBA_Environment * ev);

static GEAS_DataObject
impl_GEAS_ObjectList_getEntry(impl_POA_GEAS_ObjectList * servant,
			      CORBA_unsigned_long index,

			      CORBA_Environment * ev);

static void
impl_GEAS_ObjectList_appendObject(impl_POA_GEAS_ObjectList * servant,
				  GEAS_DataObject obj,

				  CORBA_Environment * ev);

static void
impl_GEAS_ObjectList_removeEntry(impl_POA_GEAS_ObjectList * servant,
				 CORBA_unsigned_long index,
				 CORBA_Environment * ev);

static void
impl_GEAS_ObjectList_resort(impl_POA_GEAS_ObjectList * servant,
			    CORBA_char * fieldname,
			    CORBA_boolean ascending, CORBA_Environment * ev);

static CORBA_unsigned_long
impl_GEAS_ObjectList_hideObjects(impl_POA_GEAS_ObjectList * servant,
				 CORBA_char * fieldname,
				 CORBA_char * compare,
				 CORBA_char * value, CORBA_Environment * ev);

static CORBA_unsigned_long
impl_GEAS_ObjectList_showObjects(impl_POA_GEAS_ObjectList * servant,
				 CORBA_char * fieldname,
				 CORBA_char * compare,
				 CORBA_char * value, CORBA_Environment * ev);

static void
impl_GEAS_ObjectList_showAll(impl_POA_GEAS_ObjectList * servant,
			     CORBA_Environment * ev);

static CORBA_unsigned_long
impl_GEAS_ObjectList_applyFilter(impl_POA_GEAS_ObjectList * servant,
				 CORBA_Environment * ev);

static CORBA_boolean
impl_GEAS_ObjectList__get_delayFilter(impl_POA_GEAS_ObjectList * servant,
				      CORBA_Environment * ev);
static void
impl_GEAS_ObjectList__set_delayFilter(impl_POA_GEAS_ObjectList * servant,
				      CORBA_boolean value,

				      CORBA_Environment * ev);

static void
impl_GEAS_ObjectList_release(impl_POA_GEAS_ObjectList * servant,
			     CORBA_Environment * ev);

static void
impl_GEAS_ConnectionFactory__destroy(impl_POA_GEAS_ConnectionFactory *
				     servant, CORBA_Environment * ev);
static GEAS_Connection
impl_GEAS_ConnectionFactory_guestLogin(impl_POA_GEAS_ConnectionFactory *
				       servant, CORBA_Environment * ev);

static GEAS_Connection
impl_GEAS_ConnectionFactory_unsecureLogin(impl_POA_GEAS_ConnectionFactory *
					  servant, CORBA_char * username,
					  CORBA_char * password,
					  CORBA_Environment * ev);

static CORBA_char
   *impl_GEAS_ConnectionFactory_getAuthenticationKey
   (impl_POA_GEAS_ConnectionFactory * servant, CORBA_char * username,
    CORBA_Environment * ev);

static GEAS_Connection
impl_GEAS_ConnectionFactory_getConnection(impl_POA_GEAS_ConnectionFactory *
					  servant, CORBA_char * username,
					  CORBA_char * passkey,
					  CORBA_Environment * ev);

static GEAS_Admin
impl_GEAS_ConnectionFactory_adminLogin(impl_POA_GEAS_ConnectionFactory *
				       servant, CORBA_char * username,
				       CORBA_char * passkey,
				       CORBA_Environment * ev);

static void impl_GEAS_MethodProvider__destroy(impl_POA_GEAS_MethodProvider *
					      servant,

					      CORBA_Environment * ev);
static CORBA_boolean
impl_GEAS_MethodProvider_verify(impl_POA_GEAS_MethodProvider * servant,
				CORBA_char * name, CORBA_long argcount,
				CORBA_Environment * ev);

static CORBA_char
   *impl_GEAS_MethodProvider_execute(impl_POA_GEAS_MethodProvider * servant,
				     CORBA_char * name, GEAS_Arguments * args,
				     CORBA_Environment * ev);

/*** epv structures ***/

static PortableServer_ServantBase__epv impl_GEAS_Query_Constraint_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_GEAS_Query_Constraint__epv impl_GEAS_Query_Constraint_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_Query_Constraint__get_logic,
   (gpointer) & impl_GEAS_Query_Constraint__set_logic,

   (gpointer) & impl_GEAS_Query_Constraint_addField,

   (gpointer) & impl_GEAS_Query_Constraint_newConstraint,

};
static PortableServer_ServantBase__epv impl_GEAS_Query_Query_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_GEAS_Query_Query__epv impl_GEAS_Query_Query_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_Query_Query__get_id,

   (gpointer) & impl_GEAS_Query_Query_release,

   (gpointer) & impl_GEAS_Query_Query_clear,

   (gpointer) & impl_GEAS_Query_Query__get_classname,
   (gpointer) & impl_GEAS_Query_Query__set_classname,

   (gpointer) & impl_GEAS_Query_Query__get_orderby,
   (gpointer) & impl_GEAS_Query_Query__set_orderby,

   (gpointer) & impl_GEAS_Query_Query__get_reverse,
   (gpointer) & impl_GEAS_Query_Query__set_reverse,

};
static POA_GEAS_Query_Constraint__epv
   impl_GEAS_Query_Query_GEAS_Query_Constraint_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_Query_Query__get_logic,
   (gpointer) & impl_GEAS_Query_Query__set_logic,
   (gpointer) & impl_GEAS_Query_Query_addField,
   (gpointer) & impl_GEAS_Query_Query_newConstraint,
};

static PortableServer_ServantBase__epv impl_GEAS_Admin_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_GEAS_Admin__epv impl_GEAS_Admin_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_Admin__get_debuglevel,
   (gpointer) & impl_GEAS_Admin__set_debuglevel,

   (gpointer) & impl_GEAS_Admin__get_verbose,
   (gpointer) & impl_GEAS_Admin__set_verbose,

   (gpointer) & impl_GEAS_Admin_restart,

   (gpointer) & impl_GEAS_Admin_shutdown,

};

static PortableServer_ServantBase__epv impl_GEAS_Transaction_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_GEAS_Transaction__epv impl_GEAS_Transaction_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_Transaction_begin,

   (gpointer) & impl_GEAS_Transaction_commit,

   (gpointer) & impl_GEAS_Transaction_abort,

   (gpointer) & impl_GEAS_Transaction_checkpoint,

   (gpointer) & impl_GEAS_Transaction_join,

   (gpointer) & impl_GEAS_Transaction_leave,

   (gpointer) & impl_GEAS_Transaction_isOpen,

};
static PortableServer_ServantBase__epv impl_GEAS_TransactionFactory_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_GEAS_TransactionFactory__epv impl_GEAS_TransactionFactory_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_TransactionFactory_new,

   (gpointer) & impl_GEAS_TransactionFactory_current,

};

static PortableServer_ServantBase__epv impl_GEAS_Connection_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_GEAS_Connection__epv impl_GEAS_Connection_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_Connection__get_currentUserID,

   (gpointer) & impl_GEAS_Connection__get_classes,

   (gpointer) & impl_GEAS_Connection__get_schema,

   (gpointer) & impl_GEAS_Connection_newQuery,

   (gpointer) & impl_GEAS_Connection_executeQuery,

   (gpointer) & impl_GEAS_Connection_getClassDefinition,

   (gpointer) & impl_GEAS_Connection_getFullClassDefinition,

   (gpointer) & impl_GEAS_Connection_getLookupFieldOptions,

   (gpointer) & impl_GEAS_Connection_supportsFeature,

   (gpointer) & impl_GEAS_Connection_newObject,

   (gpointer) & impl_GEAS_Connection_newEmptyList,

   (gpointer) & impl_GEAS_Connection_loadObjects,

   (gpointer) & impl_GEAS_Connection_loadAll,

   (gpointer) & impl_GEAS_Connection_loadSingleObject,

   (gpointer) & impl_GEAS_Connection_flush,

   (gpointer) & impl_GEAS_Connection_logout,

   (gpointer) & impl_GEAS_Connection_getReferenceDefinition,

   (gpointer) & impl_GEAS_Connection_clearCache,

   (gpointer) & impl_GEAS_Connection_activateEventLog,

   (gpointer) & impl_GEAS_Connection__get_latestChanges,

   (gpointer) & impl_GEAS_Connection_countAllInstances,

};
static POA_GEAS_TransactionFactory__epv
   impl_GEAS_Connection_GEAS_TransactionFactory_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_Connection_new,
   (gpointer) & impl_GEAS_Connection_current,
};

static PortableServer_ServantBase__epv impl_GEAS_DataObject_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_GEAS_DataObject__epv impl_GEAS_DataObject_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_DataObject__get_objectID,

   (gpointer) & impl_GEAS_DataObject_identity,

   (gpointer) & impl_GEAS_DataObject_ofclass,

   (gpointer) & impl_GEAS_DataObject__get_classname,

   (gpointer) & impl_GEAS_DataObject__get_classes,

   (gpointer) & impl_GEAS_DataObject__get_allfields,

   (gpointer) & impl_GEAS_DataObject_getLookupFieldOptions,

   (gpointer) & impl_GEAS_DataObject_setLookupField,

   (gpointer) & impl_GEAS_DataObject_getField,

   (gpointer) & impl_GEAS_DataObject_setField,

   (gpointer) & impl_GEAS_DataObject_getReference,

   (gpointer) & impl_GEAS_DataObject_getList,

   (gpointer) & impl_GEAS_DataObject_insert,

   (gpointer) & impl_GEAS_DataObject_setReference,

   (gpointer) & impl_GEAS_DataObject_flush,

   (gpointer) & impl_GEAS_DataObject_delete,

   (gpointer) & impl_GEAS_DataObject_callMethod,

   (gpointer) & impl_GEAS_DataObject__get_inDatabase,

};

static PortableServer_ServantBase__epv impl_GEAS_ObjectList_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_GEAS_ObjectList__epv impl_GEAS_ObjectList_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_ObjectList__get_length,

   (gpointer) & impl_GEAS_ObjectList__get_objects,

   (gpointer) & impl_GEAS_ObjectList__get_classname,

   (gpointer) & impl_GEAS_ObjectList_getEntry,

   (gpointer) & impl_GEAS_ObjectList_appendObject,

   (gpointer) & impl_GEAS_ObjectList_removeEntry,

   (gpointer) & impl_GEAS_ObjectList_resort,

   (gpointer) & impl_GEAS_ObjectList_hideObjects,

   (gpointer) & impl_GEAS_ObjectList_showObjects,

   (gpointer) & impl_GEAS_ObjectList_showAll,

   (gpointer) & impl_GEAS_ObjectList_applyFilter,

   (gpointer) & impl_GEAS_ObjectList__get_delayFilter,
   (gpointer) & impl_GEAS_ObjectList__set_delayFilter,

   (gpointer) & impl_GEAS_ObjectList_release,

};

static PortableServer_ServantBase__epv impl_GEAS_ConnectionFactory_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_GEAS_ConnectionFactory__epv impl_GEAS_ConnectionFactory_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_ConnectionFactory_guestLogin,

   (gpointer) & impl_GEAS_ConnectionFactory_unsecureLogin,

   (gpointer) & impl_GEAS_ConnectionFactory_getAuthenticationKey,

   (gpointer) & impl_GEAS_ConnectionFactory_getConnection,

   (gpointer) & impl_GEAS_ConnectionFactory_adminLogin,

};

static PortableServer_ServantBase__epv impl_GEAS_MethodProvider_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_GEAS_MethodProvider__epv impl_GEAS_MethodProvider_epv = {
   NULL,			/* _private */
   (gpointer) & impl_GEAS_MethodProvider_verify,

   (gpointer) & impl_GEAS_MethodProvider_execute,

};

/*** vepv structures ***/

static POA_GEAS_Query_Constraint__vepv impl_GEAS_Query_Constraint_vepv = {
   &impl_GEAS_Query_Constraint_base_epv,
   &impl_GEAS_Query_Constraint_epv,
};
static POA_GEAS_Query_Query__vepv impl_GEAS_Query_Query_vepv = {
   &impl_GEAS_Query_Query_base_epv,
   &impl_GEAS_Query_Query_GEAS_Query_Constraint_epv,
   &impl_GEAS_Query_Query_epv,
};

static POA_GEAS_Admin__vepv impl_GEAS_Admin_vepv = {
   &impl_GEAS_Admin_base_epv,
   &impl_GEAS_Admin_epv,
};

static POA_GEAS_Transaction__vepv impl_GEAS_Transaction_vepv = {
   &impl_GEAS_Transaction_base_epv,
   &impl_GEAS_Transaction_epv,
};
static POA_GEAS_TransactionFactory__vepv impl_GEAS_TransactionFactory_vepv = {
   &impl_GEAS_TransactionFactory_base_epv,
   &impl_GEAS_TransactionFactory_epv,
};

static POA_GEAS_Connection__vepv impl_GEAS_Connection_vepv = {
   &impl_GEAS_Connection_base_epv,
   &impl_GEAS_Connection_GEAS_TransactionFactory_epv,
   &impl_GEAS_Connection_epv,
};

static POA_GEAS_DataObject__vepv impl_GEAS_DataObject_vepv = {
   &impl_GEAS_DataObject_base_epv,
   &impl_GEAS_DataObject_epv,
};

static POA_GEAS_ObjectList__vepv impl_GEAS_ObjectList_vepv = {
   &impl_GEAS_ObjectList_base_epv,
   &impl_GEAS_ObjectList_epv,
};

static POA_GEAS_ConnectionFactory__vepv impl_GEAS_ConnectionFactory_vepv = {
   &impl_GEAS_ConnectionFactory_base_epv,
   &impl_GEAS_ConnectionFactory_epv,
};

static POA_GEAS_MethodProvider__vepv impl_GEAS_MethodProvider_vepv = {
   &impl_GEAS_MethodProvider_base_epv,
   &impl_GEAS_MethodProvider_epv,
};

